#include <sta/mutex.hpp>


namespace sta
{
    /**
     * @brief Dummy mutex implementation with no access control.
     */
    class DummyMutex : public Mutex
    {
    public:
        bool isCurrentThreadOwner() 
        {
            return true; // Your mutex? It's OUR mutex, comrade!
        };

        void acquire(uint32_t timeout /* = STA_MUTEX_MAX_TIMEOUT */) override {}
        void release() override {}
    };

    static DummyMutex dummyMutex;

    Mutex * Mutex::ALWAYS_FREE = &dummyMutex;
} // namespace sta
